part of 'generated.dart';

class GetApplicationsByStaffIdVariablesBuilder {
  String staffId;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  GetApplicationsByStaffIdVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  GetApplicationsByStaffIdVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  GetApplicationsByStaffIdVariablesBuilder(this._dataConnect, {required  this.staffId,});
  Deserializer<GetApplicationsByStaffIdData> dataDeserializer = (dynamic json)  => GetApplicationsByStaffIdData.fromJson(jsonDecode(json));
  Serializer<GetApplicationsByStaffIdVariables> varsSerializer = (GetApplicationsByStaffIdVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<GetApplicationsByStaffIdData, GetApplicationsByStaffIdVariables>> execute() {
    return ref().execute();
  }

  QueryRef<GetApplicationsByStaffIdData, GetApplicationsByStaffIdVariables> ref() {
    GetApplicationsByStaffIdVariables vars= GetApplicationsByStaffIdVariables(staffId: staffId,offset: _offset,limit: _limit,);
    return _dataConnect.query("getApplicationsByStaffId", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class GetApplicationsByStaffIdApplications {
  final String id;
  final String shiftId;
  final String staffId;
  final EnumValue<ApplicationStatus> status;
  final Timestamp? appliedAt;
  final Timestamp? checkInTime;
  final Timestamp? checkOutTime;
  final EnumValue<ApplicationOrigin> origin;
  final Timestamp? createdAt;
  final GetApplicationsByStaffIdApplicationsShift shift;
  final GetApplicationsByStaffIdApplicationsShiftRole shiftRole;
  GetApplicationsByStaffIdApplications.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  shiftId = nativeFromJson<String>(json['shiftId']),
  staffId = nativeFromJson<String>(json['staffId']),
  status = applicationStatusDeserializer(json['status']),
  appliedAt = json['appliedAt'] == null ? null : Timestamp.fromJson(json['appliedAt']),
  checkInTime = json['checkInTime'] == null ? null : Timestamp.fromJson(json['checkInTime']),
  checkOutTime = json['checkOutTime'] == null ? null : Timestamp.fromJson(json['checkOutTime']),
  origin = applicationOriginDeserializer(json['origin']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  shift = GetApplicationsByStaffIdApplicationsShift.fromJson(json['shift']),
  shiftRole = GetApplicationsByStaffIdApplicationsShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplications otherTyped = other as GetApplicationsByStaffIdApplications;
    return id == otherTyped.id && 
    shiftId == otherTyped.shiftId && 
    staffId == otherTyped.staffId && 
    status == otherTyped.status && 
    appliedAt == otherTyped.appliedAt && 
    checkInTime == otherTyped.checkInTime && 
    checkOutTime == otherTyped.checkOutTime && 
    origin == otherTyped.origin && 
    createdAt == otherTyped.createdAt && 
    shift == otherTyped.shift && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, shiftId.hashCode, staffId.hashCode, status.hashCode, appliedAt.hashCode, checkInTime.hashCode, checkOutTime.hashCode, origin.hashCode, createdAt.hashCode, shift.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['shiftId'] = nativeToJson<String>(shiftId);
    json['staffId'] = nativeToJson<String>(staffId);
    json['status'] = 
    applicationStatusSerializer(status)
    ;
    if (appliedAt != null) {
      json['appliedAt'] = appliedAt!.toJson();
    }
    if (checkInTime != null) {
      json['checkInTime'] = checkInTime!.toJson();
    }
    if (checkOutTime != null) {
      json['checkOutTime'] = checkOutTime!.toJson();
    }
    json['origin'] = 
    applicationOriginSerializer(origin)
    ;
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    json['shift'] = shift.toJson();
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  GetApplicationsByStaffIdApplications({
    required this.id,
    required this.shiftId,
    required this.staffId,
    required this.status,
    this.appliedAt,
    this.checkInTime,
    this.checkOutTime,
    required this.origin,
    this.createdAt,
    required this.shift,
    required this.shiftRole,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShift {
  final String id;
  final String title;
  final Timestamp? date;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final String? location;
  final EnumValue<ShiftStatus>? status;
  final GetApplicationsByStaffIdApplicationsShiftOrder order;
  GetApplicationsByStaffIdApplicationsShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  status = json['status'] == null ? null : shiftStatusDeserializer(json['status']),
  order = GetApplicationsByStaffIdApplicationsShiftOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShift otherTyped = other as GetApplicationsByStaffIdApplicationsShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    location == otherTyped.location && 
    status == otherTyped.status && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, startTime.hashCode, endTime.hashCode, location.hashCode, status.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    if (status != null) {
      json['status'] = 
    shiftStatusSerializer(status!)
    ;
    }
    json['order'] = order.toJson();
    return json;
  }

  GetApplicationsByStaffIdApplicationsShift({
    required this.id,
    required this.title,
    this.date,
    this.startTime,
    this.endTime,
    this.location,
    this.status,
    required this.order,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShiftOrder {
  final String id;
  final String? eventName;
  final GetApplicationsByStaffIdApplicationsShiftOrderTeamHub teamHub;
  final GetApplicationsByStaffIdApplicationsShiftOrderBusiness business;
  final GetApplicationsByStaffIdApplicationsShiftOrderVendor? vendor;
  GetApplicationsByStaffIdApplicationsShiftOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  teamHub = GetApplicationsByStaffIdApplicationsShiftOrderTeamHub.fromJson(json['teamHub']),
  business = GetApplicationsByStaffIdApplicationsShiftOrderBusiness.fromJson(json['business']),
  vendor = json['vendor'] == null ? null : GetApplicationsByStaffIdApplicationsShiftOrderVendor.fromJson(json['vendor']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShiftOrder otherTyped = other as GetApplicationsByStaffIdApplicationsShiftOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    teamHub == otherTyped.teamHub && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, teamHub.hashCode, business.hashCode, vendor.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    json['teamHub'] = teamHub.toJson();
    json['business'] = business.toJson();
    if (vendor != null) {
      json['vendor'] = vendor!.toJson();
    }
    return json;
  }

  GetApplicationsByStaffIdApplicationsShiftOrder({
    required this.id,
    this.eventName,
    required this.teamHub,
    required this.business,
    this.vendor,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShiftOrderTeamHub {
  final String address;
  final String? placeId;
  final String hubName;
  GetApplicationsByStaffIdApplicationsShiftOrderTeamHub.fromJson(dynamic json):
  
  address = nativeFromJson<String>(json['address']),
  placeId = json['placeId'] == null ? null : nativeFromJson<String>(json['placeId']),
  hubName = nativeFromJson<String>(json['hubName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShiftOrderTeamHub otherTyped = other as GetApplicationsByStaffIdApplicationsShiftOrderTeamHub;
    return address == otherTyped.address && 
    placeId == otherTyped.placeId && 
    hubName == otherTyped.hubName;
    
  }
  @override
  int get hashCode => Object.hashAll([address.hashCode, placeId.hashCode, hubName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['address'] = nativeToJson<String>(address);
    if (placeId != null) {
      json['placeId'] = nativeToJson<String?>(placeId);
    }
    json['hubName'] = nativeToJson<String>(hubName);
    return json;
  }

  GetApplicationsByStaffIdApplicationsShiftOrderTeamHub({
    required this.address,
    this.placeId,
    required this.hubName,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShiftOrderBusiness {
  final String id;
  final String businessName;
  final String? email;
  final String? contactName;
  GetApplicationsByStaffIdApplicationsShiftOrderBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']),
  email = json['email'] == null ? null : nativeFromJson<String>(json['email']),
  contactName = json['contactName'] == null ? null : nativeFromJson<String>(json['contactName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShiftOrderBusiness otherTyped = other as GetApplicationsByStaffIdApplicationsShiftOrderBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName && 
    email == otherTyped.email && 
    contactName == otherTyped.contactName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode, email.hashCode, contactName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    if (email != null) {
      json['email'] = nativeToJson<String?>(email);
    }
    if (contactName != null) {
      json['contactName'] = nativeToJson<String?>(contactName);
    }
    return json;
  }

  GetApplicationsByStaffIdApplicationsShiftOrderBusiness({
    required this.id,
    required this.businessName,
    this.email,
    this.contactName,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShiftOrderVendor {
  final String id;
  final String companyName;
  GetApplicationsByStaffIdApplicationsShiftOrderVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShiftOrderVendor otherTyped = other as GetApplicationsByStaffIdApplicationsShiftOrderVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  GetApplicationsByStaffIdApplicationsShiftOrderVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShiftRole {
  final String id;
  final String roleId;
  final int count;
  final int? assigned;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final double? hours;
  final double? totalValue;
  final GetApplicationsByStaffIdApplicationsShiftRoleRole role;
  GetApplicationsByStaffIdApplicationsShiftRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  roleId = nativeFromJson<String>(json['roleId']),
  count = nativeFromJson<int>(json['count']),
  assigned = json['assigned'] == null ? null : nativeFromJson<int>(json['assigned']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = GetApplicationsByStaffIdApplicationsShiftRoleRole.fromJson(json['role']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShiftRole otherTyped = other as GetApplicationsByStaffIdApplicationsShiftRole;
    return id == otherTyped.id && 
    roleId == otherTyped.roleId && 
    count == otherTyped.count && 
    assigned == otherTyped.assigned && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, roleId.hashCode, count.hashCode, assigned.hashCode, startTime.hashCode, endTime.hashCode, hours.hashCode, totalValue.hashCode, role.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['roleId'] = nativeToJson<String>(roleId);
    json['count'] = nativeToJson<int>(count);
    if (assigned != null) {
      json['assigned'] = nativeToJson<int?>(assigned);
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    return json;
  }

  GetApplicationsByStaffIdApplicationsShiftRole({
    required this.id,
    required this.roleId,
    required this.count,
    this.assigned,
    this.startTime,
    this.endTime,
    this.hours,
    this.totalValue,
    required this.role,
  });
}

@immutable
class GetApplicationsByStaffIdApplicationsShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  GetApplicationsByStaffIdApplicationsShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdApplicationsShiftRoleRole otherTyped = other as GetApplicationsByStaffIdApplicationsShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  GetApplicationsByStaffIdApplicationsShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class GetApplicationsByStaffIdData {
  final List<GetApplicationsByStaffIdApplications> applications;
  GetApplicationsByStaffIdData.fromJson(dynamic json):
  
  applications = (json['applications'] as List<dynamic>)
        .map((e) => GetApplicationsByStaffIdApplications.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdData otherTyped = other as GetApplicationsByStaffIdData;
    return applications == otherTyped.applications;
    
  }
  @override
  int get hashCode => applications.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['applications'] = applications.map((e) => e.toJson()).toList();
    return json;
  }

  GetApplicationsByStaffIdData({
    required this.applications,
  });
}

@immutable
class GetApplicationsByStaffIdVariables {
  final String staffId;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  GetApplicationsByStaffIdVariables.fromJson(Map<String, dynamic> json):
  
  staffId = nativeFromJson<String>(json['staffId']) {
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByStaffIdVariables otherTyped = other as GetApplicationsByStaffIdVariables;
    return staffId == otherTyped.staffId && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([staffId.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['staffId'] = nativeToJson<String>(staffId);
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  GetApplicationsByStaffIdVariables({
    required this.staffId,
    required this.offset,
    required this.limit,
  });
}

